       program FAST_GROUPS          
c
C       TOTAL EFFECT INDICES AND FIRST ORDER INDICES FOR A GIVEN MODEL
C	COMPUTED WITH EXTENDED FAST 
C
c	THIS PROGRAM ALLOWS REGROUPING OF FACTORS
C
c	latest version 28/05/1998  by STEFANO TARANTOLA
C
C-----------------------------------------------------------------------
C       INPUT:   ./TIMEVALUES2.DAT
C		 ./***/INPUTDATA.INP
C
C	OUTPUT:  FIRST ORDER  SENSITIVITY INDICES --->
C                --->  ./***/si%.%.np%
C	OUTPUT:  TOTAL EFFECT SENSITIVITY INDICES ---> 
C                --->  ./***/sti%.%.np%
C-----------------------------------------------------------------------
C
      IMPLICIT REAL (A-H,P-Z)
      INTEGER OM,OMI,OMGRCI,OMGRI,OMIMAX,OMIMIN,
     + P,PE,Q,DELTA,HH,OMCIMAX,R,OMGRP,GR
      
      REAL  M1,M2,FI
	real*8 Egendre,DUM8
      INCLUDE 'par.h'
      INCLUDE 'cparam.h'                                                        
      INCLUDE 'cvaria.h' 
      INCLUDE 'cfast.h'
      include 'ctime.h'                                                      
      INCLUDE 'cspop.h'                                                            
      
      DIMENSION OM(MXNVAR),OMGRI(MXNVAR),OMGRCI(MXNVAR),
     +		NELGRP(MXNGRP), 
     +          matranks(MXNVAR,MXNRUN),		!matrix 
     +          AC(MXNRUN),BC(MXNRUN),			!Fourier Coefficients
     +          FI(MXNVAR),				!phase shift
     +          ADCI(MXNTIM,MXNCHN),
     +          AD(MXNTIM,MXNCHN),
     +          DCI(MXNTIM,MXNCHN),			! part. var. of the compl. set of par.
     +          D(MXNTIM,MXNCHN),			! total output variance
     +          STI(MXNREP,MXNVAR,MXNTIM,MXNCHN),	! total effect sens. index
     +          ADI(MXNTIM,MXNCHN),
     +          DI(MXNTIM,MXNCHN),			! part. variance of par. i
     +          SI(MXNREP,MXNVAR,MXNTIM,MXNCHN),	! first order sens. index
     +          GR(MXNGRP,MXNVAR),			! partition of parameters into groups
     +		Y(MXNTIM),				! model output (single run)
     +		UU(MXNTIM,MXNCHN,MXNRUN),		! model output matrix
     +          U(MXNRUN),				! model output (single time)
     +		indx(mxnrep),
     +		SIAN(MXNGRP),STIAN(MXNGRP),
     +		S1(MXNREP),ST1(MXNREP),
     +		ESI(MXNGRP),ESTI(MXNGRP)

c       INCLUDE './g_function/inputdata.inp'      
c	include './g_function/pdf.h'
c        INCLUDE './testcase1/inputdata.inp'      
c	include './testcase1/pdf.h'
c        INCLUDE './testcase6/inputdata.inp'      
c	include './testcase6/pdf.h'
c        INCLUDE './additive_1/inputdata.inp'      
c	include './additive_1/pdf.h'
c        INCLUDE './Gardner/inputdata.inp'      
c	include './Gardner/pdf.h'
c        INCLUDE './legendre/inputdata.inp'      
c	include './legendre/pdf.h'
c        INCLUDE './c_sobol/22groups/inputdata.inp'      
c	include './c_sobol/22groups/pdf.h'
c        INCLUDE './Bartowiack/inputdata.inp'      
c	include './Bartowiack/pdf.h'
c        INCLUDE './expon_function/inputdata.inp'      
c	include './expon_function/pdf.h'
        INCLUDE './additiv_with_noise/inputdata.inp'      
	include './additiv_with_noise/pdf.h'

        IOUT=MXNTIM
	open(unit=22,file='timevalues2.dat')
c	open(unit=22,file='timestestcase6.dat')
	READ(22,*) (TOUT(I), I=1,IOUT)
	close(22)        

	PI=4*DATAN(1.D0)
      
C------------------
C       COMPUTATION  OF SAMPLE SIZE
C-------------------      

      NRUNS=2*MI*OMI+1      
      NQ=(NRUNS-1)/2
      N0=NQ+1
      NT=NRUNS*NR      
      write(*,11) NT
11    format(1x,'Number of samples per factor ---> ',i5)
 
      IF (NRUNS.GT.MXNRUN) THEN
        WRITE(*,*)'Warning: NRUNS>MXNRUN! Choose MXNRUN greater'  
        STOP
      END IF

      ISEED=7407
      ISEED=7409
      DITR=0.	  !distribution truncation
      CALL EQUDIV

	write(55,*) nruns
	write(55,*) nvars
	write(55,*) '0'

      DO HH=1,NP       !repeat the experiment NP times
	write(*,*) 'HH = ',hh
      DO L=1,NGRPS    !loop on number of GROUPS

C
C     ALGORITHM FOR SELECTING THE SET OF FREQUENCIES 
C
	KI=NELGRP(L)	!POPULATION OF GROUP OF INTEREST
	KCI=NVARS-KI	!POPULATION OF THE COMPLEM. GROUP
	OMCIMAX=OMI/(2.*MCI)
	CALL SETFREQ(NVARS,KCI,OMCIMAX,OMGRCI)
C
C	OMGRCI(I), I=1,KCI CONTAINS THE SET OF FREQUENCIES 
C	TO BE USED FOR THE COMPLEMENTARY GROUP 
C
c	SETTING THE VECTOR OF FREQUENCIES 'OM' FOR THE 'NVARS' FACTORS
c
	DO I=1,KI	!FOR THE GROUP OF INTEREST
	  OM(GR(L,I))=OMI
	END DO
	II=1		!FOR THE COMPL GROUP
	DO NG=1,NGRPS
	  IF(NG.NE.L) THEN
	    DO I=1,NELGRP(NG)
	      OM(GR(NG,I))=OMGRCI(II)
	      II=II+1
	    END DO
	  END IF
	END DO
	WRITE(*,*) OM
	PAUSE
C	INITIALISATION OF MATRICES ADCI,DCI        
        DO ITIME=1,IOUT
          DO NCHAIN=1,MXNCHN
            ADCI(ITIME,NCHAIN)=0.
            ADI(ITIME,NCHAIN)=0.
            AD(ITIME,NCHAIN)=0.
          END DO
        END DO
        
        DO R=1,NR 		!number of search-curves within K^n
          
          DO J=1,NVARS
            FI(J)=RAN1(ISEED)*2*PI    
          END DO    
                            
          CALL PARCOMB2(OM,FI,MATRANKS)          
          DO    NRUN = 1, NRUNS                                              

	    CALL ASSIGN(matranks)  !output ---> xvar(nvars)
	    write(55,*) (xvar(nvar),nvar=1,nvars)
	    
c            CALL SCRAM(IOUT,TOUT,XVAR,Y)
c            CALL G_FUNCTION(IOUT,TOUT,NVARS,XVAR,Y)
c            CALL C_SOBOL(IOUT,TOUT,NVARS,XVAR,Y)	    
C            CALL ADDITIVE_1(IOUT,TOUT,NVARS,XVAR,Y)
c            CALL GARDNER(IOUT,TOUT,NVARS,XVAR,Y)
c	     DUM8=XVAR(2)
c             Y(1)=real(Egendre(INT(XVAR(1)),DUM8))            	    
c            CALL BARTOWIACK(IOUT,TOUT,NVARS,XVAR,Y)	    
c             CALL EXPON_FUNCTION(IOUT,TOUT,NVARS,XVAR,Y)	      
c              CALL testcase1(IOUT,TOUT,NVARS,XVAR,Y)	                            
c             CALL testcase6(IOUT,TOUT,NVARS,XVAR,Y)	                            
             CALL ADDITIV_with_NOISE(IOUT,TOUT,NVARS,XVAR,Y)

	    DO ITIME=1,IOUT
              UU(itime,1,nrun)=Y(itime)
            end do           

          END DO   !NRUN=1,NRUNS

          DO ITIME=1,IOUT            
	    DO NCHAIN=1,MXNCHN
              M1=0.D0
              DO NRUN=1,NRUNS
                U(NRUN)= UU(ITIME,nchain,NRUN)	    
c		write(*,*) U(nrun)
c		pause
		M1=M1+U(NRUN)
              end do
              M1=M1/NRUNS

C	SUBTRACTING THE AVERAGE VALUE              
       	      DO NRUN=1,NRUNS
       	        U(NRUN)=U(NRUN)-M1
       	      END DO
C-----------------------------------------
C     COMPUTATION OF FOURIER COEFFICIENTS
C-----------------------------------------
C
C       Fourier coeff. in [1,omi/2] or [1,MCI*OMCIMAX]
C
 	  COMPL=0.D0

 	  DO J=1,OMI/2               
              AC(J)=0.D0
              BC(J)=0.D0
              SP1=U(N0)
              SP2=0.D0
              DO Q=1,NQ
                SP1=SP1+(U(N0+Q)+U(N0-Q))*DCOS(1.*J*2.D0*Q*PI/NRUNS) 
                SP2=SP2+(U(N0+Q)-U(N0-Q))*DSIN(1.*J*2.D0*Q*PI/NRUNS)
              END DO
              AC(J)=SP1/NRUNS
              BC(J)=SP2/NRUNS
c              WRITE(20,15) J,AC(J)**2+BC(J)**2
              COMPL=COMPL+AC(J)**2+BC(J)**2    
	  END DO      
c
C      Computation of D_{(-I)}
C           	                  
          DCI(ITIME,NCHAIN)=2*COMPL
          ADCI(ITIME,NCHAIN)=ADCI(ITIME,NCHAIN)+DCI(ITIME,NCHAIN)
C
C       Fourier coeff. at [P*OMI, for P=1,MI]
C
	  COMPL=0.D0

          DO P=1,MI
            J=P*OMI             
            AC(J)=0.D0
            BC(J)=0.D0
            SP1=U(N0)
            SP2=0.D0
            DO Q=1,NQ
              SP1=SP1+(U(N0+Q)+U(N0-Q))*DCOS(1.*J*2.D0*Q*PI/NRUNS) 
              SP2=SP2+(U(N0+Q)-U(N0-Q))*DSIN(1.*J*2.D0*Q*PI/NRUNS)
            END DO
            AC(J)=SP1/NRUNS
            BC(J)=SP2/NRUNS
C
C      Computation of D_I
C            
            COMPL=COMPL+AC(J)**2+BC(J)**2
          END DO
            
          DI(ITIME,NCHAIN)=2*COMPL

          ADI(ITIME,NCHAIN)=ADI(ITIME,NCHAIN)+DI(ITIME,NCHAIN)
C
C        COMPUTATION OF THE TOTAL VARIANCE IN THE TIME DOMAIN
C           
          M2=0.D0
          DO J=1,NRUNS
            M2=M2+U(J)**2
          END DO          
          D(ITIME,NCHAIN)=M2/NRUNS

	  AD(ITIME,NCHAIN)=AD(ITIME,NCHAIN)+D(ITIME,NCHAIN)
	END DO  ! NCHAIN=1,MXNCHN        

        END DO  ! ITIME=1,IOUT
                
      END DO  !R=1,NR        

C-------------------------------------
C     COMPUTE SENSITIVITY INDICES
C-------------------------------------
      DO ITIME=1,IOUT
        DO NCHAIN=1,MXNCHN
          AD(ITIME,NCHAIN)=AD(ITIME,NCHAIN)/NR               
          ADI(ITIME,NCHAIN)=ADI(ITIME,NCHAIN)/NR
          ADCI(ITIME,NCHAIN)=ADCI(ITIME,NCHAIN)/NR
	  SI(HH,L,ITIME,NCHAIN)=ADI(ITIME,NCHAIN)/AD(ITIME,NCHAIN)
	  STI(HH,L,ITIME,NCHAIN)=1.-ADCI(ITIME,NCHAIN)/AD(ITIME,NCHAIN)
        END DO
      END DO     
15      FORMAT(1X,I5,2X,1PE12.5)              
      END DO    !L=1,NGRPS       
	write(81,*) HH,SI(HH,1,1,1),STI(HH,1,1,1)
	write(82,*) HH,SI(HH,2,1,1),STI(HH,2,1,1)
c	write(83,*) HH,SI(HH,3,1,1),STI(HH,3,1,1)
      END DO     !HH=1,NP    	                 
C	close(55)
	close(81)
	close(82)	
c	close(83)	

	stop
	end
