C
C     To compile 'f77 -C -c legendre.f
C
      Function Egendre(N,x)
      Implicit Double Precision(a-h,o-z)
c
c     Legendre functions, Spherical, Abram. & Stegun page 775
c
      sum=0.0d0
      nsup=N/2
      do  M=0,nsup
C         write(6,*) ' function legendre,  N,M ', N,M
          sum=sum+ccoeff(M,N)*g(N,M,x)
C         write(6,*) ' function legendre,  sum ', sum
      end do
      Egendre=sum*dcoeff(N)
      return
      end
c
      Function ifactor(N)
      Implicit Double Precision(a-h,o-z)
      ifactor=1
      if(N.gt.0) then
          do j=N,1,-1
              ifactor=ifactor*j
          end do
          return
          elseif(N.eq.0) then
            return 
        else
          write(6,*) ' error in function factor'
          write(6,*) 'N = ',N
          stop
      endif
      end
c
      Function ibinom(N,K)
      Implicit Double Precision(a-h,o-z) 
      num=ifactor(N)
      nden=ifactor(K)*ifactor(N-K)
C      write(6,*) 'function binom N,K,num,nden', N,K,num,nden
      ibinom=num/nden
      return
      end
c
      Function dcoeff(N)
      Implicit Double Precision(a-h,o-z)
c
c     d(N) coefficient for Legendre functions, Abram. & Stegun page 775
c
      dcoeff=1./2**N
      return
      end
c
      Function ccoeff(M,N)
      Implicit Double Precision(a-h,o-z) 
c
c     c(N) coefficient for Legendre functions, Abram. & Stegun page 775
c
C      write(6,*) 'function ccoeff M,N ', ccoeff, M, N
      msign=(-1)**M
      bin1=dfloat(ibinom(N,M))
      NN=2*N-2*M
      bin2=dfloat(ibinom(NN, N))
      ccoeff=msign*bin1*bin2
c     write(6,*) ' function ccoeff ccoeff ' , ccoeff
      return
      end
c
      Function g(N,M,x)
      Implicit Double Precision(a-h,o-z)
c
c     g(N,M,x) function for Legendre functions, Abram. & Stegun page 775
c
      NN=N-2*M
      g=x**NN
      return
      end
